/**********************************************************************
 * File Name: Message.java
 *
 * Copyright (C) 2000, US Air Force Research Laboratory,
 * Rome Research Site, Rome NY 13424, USA.
 *
 * Use of this software implies acceptance of the terms described in
 * accompanying license.txt file.
 *
 *
 * Authors: Bob Paragi, John Crowter, James Lawton,
 *          Jennifer Dzek, and Joe Beasock
 *
 * Creation Date: December 1999
 *
 * Description:
 *
 * Modification History:
 *
 **********************************************************************/

import java.lang.*;
import java.io.*;
import java.util.*;

public class Message {
    public String text;
    public String message_id;
    public String sender;
    public String receiver;
    //public int transmit_channel;
    public int timestamp;
    public String [] parsedMessage;
    public ConnectionItem agentSocket;

    public Message () {
	text = "Unknown";
    }

    // A message is a string of the format:
    //   "Msg_ID Sender Reciever Timestamp <data>"
    public Message (String m) {
	text = m;
	StringTokenizer s = new StringTokenizer(m);
	int n = s.countTokens ();
	message_id = s.nextToken();
	sender = s.nextToken();
	receiver = s.nextToken();
	//transmit_channel = Integer.parseInt(s.nextToken());
	timestamp = Integer.parseInt(s.nextToken());
	if (n > 4) {
	    n = n - 4;
	    parsedMessage = new String [n];
	    for (int i = 0; i < n ; i++) {
		parsedMessage[i] = s.nextToken();
	    };
	}
	
	agentSocket = null;
    }

    public String text(){
	return text;
    }

    public String message_id(){
	return message_id;
    }

    public String sender(){
	return sender;
    }

    public String receiver() {
	return receiver;
    }


    /*
    public int transmit_channel() {
	return transmit_channel;
    }
    */

    public Message reply (String sndr, int timestamp, String msg) {

	String newText = message_id + " " + sndr + " " + sender + " "
	    + " " + timestamp + " " + msg;
	Message newMessage = new Message( newText );
	newMessage.agentSocket = agentSocket;
	return newMessage;
    }

    public Message reply (String sndr, String type, int timestamp, String msg) {
	int ind = message_id.indexOf("_") + 1;
	String new_message_id = message_id.substring(0,ind) + type +  message_id.substring(ind+1);
	String newText = new_message_id + " " + sndr + " " + sender + " " + " " + timestamp + " " + msg;
	Message newMessage = new Message( newText );
	newMessage.agentSocket = agentSocket;

	return newMessage;
    }

    public Message copy() {
	return ( new Message( text ) );
    }

}
